﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MontoyaTech.Rest.Net
{
    /// <summary>
    /// The outline of an attribute that can be used to rename a type when it's used in routes.
    /// </summary>
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Struct, AllowMultiple = false, Inherited = false)]
    public class RouteTypeName : Attribute
    {
        /// <summary>
        /// The new name for this type.
        /// </summary>
        public string Name;

        public RouteTypeName(string name)
        {
            this.Name = name;
        }
    }
}
